// SmultronKit, www.peterborgapps.com/smultron
// Copyright © 2004-2015 Peter Borg Apps AB


#import <Foundation/Foundation.h>

#import "SmultronKit.h"

#pragma mark - NSString

extern NSString * const SMLSyntaxName;
extern NSString * const SMLSyntaxClass;
extern NSString * const SMLSyntaxExtensions;

extern NSString * const SMLKeyThemes;
extern NSString * const SMLKeyCurrentTheme;

extern NSString * const SMLKeyTextFont;
extern NSString * const SMLKeyCommandsColor;
extern NSString * const SMLKeyCommentsColor;
extern NSString * const SMLKeyInstructionsColor;
extern NSString * const SMLKeyKeywordsColor;
extern NSString * const SMLKeyVariablesColor;
extern NSString * const SMLKeyStringsColor;
extern NSString * const SMLKeyAttributesColor;

extern NSString * const SMLKeyBackgroundColor;
extern NSString * const SMLKeyTextColor;
extern NSString * const SMLKeyInvisibleTextColor;
extern NSString * const SMLKeySelectedTextColor;
extern NSString * const SMLKeyHighlightLineColor;

extern NSString * const SMLKeySnippets;
extern NSString * const SMLKeyCommands;
extern NSString * const SMLKeySyntax;

extern NSString * const SMLKeyTabWidth;
extern NSString * const SMLKeyShowPageGuideAtColumn;
extern NSString * const SMLKeyFullScreenWidth;
extern NSString * const SMLKeyAutocompleteAfterDelay;
extern NSString * const SMLKeyOpenDocumentsSize;
extern NSString * const SMLKeyAlwaysUseTextEncoding;
extern NSString * const SMLKeyEncodingsPopUp;
extern NSString * const SMLKeyShowSyntaxColors;
extern NSString * const SMLKeyLineWrap;
extern NSString * const SMLKeyAutoSave;
extern NSString * const SMLKeyShowInvisibleCharacters;
extern NSString * const SMLKeyShowStatusBar;
extern NSString * const SMLKeyShowLineNumbers;
extern NSString * const SMLKeyShowPathBar;
extern NSString * const SMLKeySplitWindow;
extern NSString * const SMLKeyIndentNewLinesAutomatically;
extern NSString * const SMLKeyIndentWithSpaces;
extern NSString * const SMLKeyAutocompleteSuggestAutomatically;
extern NSString * const SMLKeyAutocompleteIncludeStandardWords;
extern NSString * const SMLKeyUseTabStops;
extern NSString * const SMLKeyHighlightCurrentLine;
extern NSString * const SMLKeyIgnoreCaseAdvancedFind;
extern NSString * const SMLKeyUseRegularExpressionsAdvancedFind;
extern NSString * const SMLKeyOnlyInSelectionAdvancedFind;
extern NSString * const SMLKeyPrintHeader;
extern NSString * const SMLKeyPrintSyntaxColors;
extern NSString * const SMLKeyOnlyPrintSelection;
extern NSString * const SMLKeyCascadeNewWindows;
extern NSString * const SMLKeyRunText;
extern NSString * const SMLKeyMarginsMin;
extern NSString * const SMLKeyPrintFont;
extern NSString * const SMLKeyPrintLineNumbers;
extern NSString * const SMLKeyMultiTouchGestures;
extern NSString * const SMLKeyDocumentsWindowOnTop;
extern NSString * const SMLKeyShowPositionInStatusBar;
extern NSString * const SMLKeyUTF8WithBOM;
extern NSString * const SMLKeyShowFullPath;
extern NSString * const SMLKeyDocumentViewType;
extern NSString * const SMLKeyConvertLineEndings;
extern NSString * const SMLKeyLineEndings;
extern NSString * const SMLKeyAutomaticDashSubstitution;
extern NSString * const SMLKeyAutomaticDataDetection;
extern NSString * const SMLKeyAutomaticLinkDetection;
extern NSString * const SMLKeyAutomaticQuoteSubstitution;
extern NSString * const SMLKeyAutomaticSpellingCorrection;
extern NSString * const SMLKeyAutomaticTextReplacement;
extern NSString * const SMLKeyContinuousSpellChecking;
extern NSString * const SMLKeyGrammarChecking;
extern NSString * const SMLKeySmartInsertDelete;
extern NSString * const SMLKeyResumePreferencesToolbarItem;
extern NSString * const SMLKeyAdvancedFindSearchScope;
extern NSString * const SMLKeyAdvancedFindFolderBookmark;
extern NSString * const SMLKeySortDocumentsDateModified;
extern NSString * const SMLKeyAlwaysUseFileNameExtension;
extern NSString * const SMLKeyFileNameExtension;



extern NSString * const SMLKeyDisplayName;
extern NSString * const SMLKeyLastModifiedDate;


extern NSString * const SMLKeyPathContentInline;
extern NSString * const SMLKeyPathContentSuppressResult;
extern NSString * const SMLKeyPathContentName;
extern NSString * const SMLKeyPathContentText;
extern NSString * const SMLKeyPathSelected;


extern NSString * const SMLKeyMergeAllWindows;
extern NSString * const SMLKeySecurityBookmarks;

extern NSString * const SMLKeyShowSidebar;
extern NSString * const SMLKeyShowTabBar;
extern NSString * const SMLKeyShowPageGuide;

extern NSString * const SMLKeyEncodingName;
extern NSString * const SMLKeyEncodingTag;

extern NSString * const SMLKeySyncKeyValue;
extern NSString * const SMLKeyMoveWindowWhenSwitching;


extern NSString * const SMLToolbarItemGeneral;
extern NSString * const SMLToolbarItemAdvanced;

extern NSString * const SMLKeySnippetName;
extern NSString * const SMLKeySnippetText;

extern NSString * const SMLKeyCommandName;
extern NSString * const SMLKeyCommandText;
extern NSString * const SMLKeyCommandInline;
extern NSString * const SMLKeyCommandSuppressResult;
extern NSString * const SMLKeyCommandInterpreter;

extern NSString * const SMLContainerID;

extern NSString * const SMLSecurityBookmarksFileName;

extern NSString * const SMLFontSeparatorString;

extern NSString * const SMLTextFoldingAttributeName;

extern NSString * const SMLSyntaxKeyStandardKeywordStartCharacter;
extern NSString * const SMLSyntaxKeyStandardKeywordRemoveEndCharacter;

extern NSString * const SMLInfoKeyFileSize;
extern NSString * const SMLInfoKeyWhere;
extern NSString * const SMLInfoKeyCreated;
extern NSString * const SMLInfoKeyModified;
extern NSString * const SMLInfoKeyName;
extern NSString * const SMLInfoKeyLength;
extern NSString * const SMLInfoKeySelection;
extern NSString * const SMLInfoKeyPosition;
extern NSString * const SMLInfoKeyLines;
extern NSString * const SMLInfoKeyFunction;
extern NSString * const SMLInfoKeyWords;

extern NSString * const SMLFunctionKeyLineNumber;
extern NSString * const SMLFunctionKeyName;


extern NSString * const SMLNodeKeyDisplayString;
extern NSString * const SMLNodeKeyIsLeaf;
extern NSString * const SMLNodeKeyRepresentedObject;
extern NSString * const SMLNodeKeyRange;
extern NSString * const SMLNodeKeyResultString;

extern NSString * const SMLScopeKeyDocuments;
extern NSString * const SMLScopeKeyURLs;


extern NSString * const SMLSearchResultNode;
extern NSString * const SMLSearchResultIndexPath;


extern NSString * const SMLTransformerTextCompressor;
extern NSString * const SMLTransformerPath;
extern NSString * const SMLTransformerFont;
extern NSString * const SMLTransformerFontString;
extern NSString * const SMLTransformerColorWell;


extern NSString * const SMLToolbarItemAdd;
extern NSString * const SMLToolbarItemAdvancedFind;
extern NSString * const SMLToolbarItemShare;
extern NSString * const SMLToolbarItemPreview;
extern NSString * const SMLToolbarItemInfo;
extern NSString * const SMLToolbarItemClose;
extern NSString * const SMLToolbarItemQuickLook;
extern NSString * const SMLToolbarItemFunctions;
extern NSString * const SMLToolbarItemDocuments;
extern NSString * const SMLToolbarItemTabBar;
extern NSString * const SMLToolbarItemOpen;
extern NSString * const SMLToolbarItemSave;

//extern NSString * const SMLRegistrationURLScheme;

extern NSString * const SMLRestoreHasManuallyChangedSyntax;
extern NSString * const SMLRestoreSyntaxName;

extern NSString * const SMLCellDocument;
extern NSString * const SMLCellStandard;
extern NSString * const SMLCellInfo;

extern NSString * const SMLMagicPrefix;

extern NSString * const SMLKeySyntaxColorDictionary;
extern NSString * const SMLKeySyntaxRange;

extern NSString * const SMLDefaultIcon;
extern NSString * const SMLGenericIcon;

extern NSString * const SMLKeyFileURL;
extern NSString * const SMLKeyFileName;
extern NSString * const SMLKeyFileIcon;
extern NSString * const SMLKeyFileDetail;

extern NSString * const SMLKeyConflictDevice;
extern NSString * const SMLKeyConflictVersion;

extern NSString * const SMLStoryboardIdentifierShowPreview;
extern NSString * const SMLStoryboardIdentifierShowConflict;
extern NSString * const SMLStoryboardIdentifierShowDocuments;

extern NSString * const SMLKeyResumeBookmarkData;

extern NSString * const SMLKeyRecentExternalPaths;

extern NSString * const SMLCheckBundleIdentifier;
extern NSString * const SMLCheckAppName;

extern NSString * const SMLDefaultsKeyRegistrationName;
extern NSString * const SMLDefaultsKeyRegistrationCode;
extern NSString * const SMLProductCode;
extern NSString * const SMLStoreID;
extern NSString * const SMLStoreProductID;
extern NSString * const SMLRegistrationURLScheme;


#pragma mark - Integer

extern NSUInteger const SMLNumberOfRecentSearches;
extern NSUInteger const SMLNumberOfRecentDocuments;


#pragma mark - CGFloat

extern CGFloat const SMLTextInsertPoints;
extern CGFloat const SMLDefaultLineNumberWidth;
extern CGFloat const SMLDocumentIconHeight;
extern CGFloat const SMLDocumentIconWidth;
extern CGFloat const SMLSidebarDefaultWidth;
extern CGFloat const SMLSidebarMargin;

extern CGFloat const SMLAnimationDuration;
extern CGFloat const SMLPopoverWidth;

extern CGFloat const SMLLineNumbersWidth;

extern CGFloat const SMLThumbnailSize;


#pragma mark - Typedef

typedef NS_ENUM(NSUInteger, SMLFontStringArray) {
	SMLFontStringArrayName = 0,
    SMLFontStringArraySize = 1,
};


typedef NS_ENUM(NSUInteger, SMLViewAnimationStyle) {
	SMLViewAnimationStyleUpwards = 0,
	SMLViewAnimationStyleDownwards = 1,
	SMLViewAnimationStyleLeftToRight = 2,
	SMLViewAnimationStyleRightToLeft = 3
};


typedef NS_ENUM(NSUInteger, SMLChosenEncoding) {
	SMLNoChosenEncoding = 0
};


typedef NS_ENUM(NSUInteger, SMLValidateAppMenu) {
	SMLValidateAppMenuCheckForUpdates = 1,
	SMLValidateAppMenuPurchase = 2,
	SMLValidateAppMenuLicense = 3,
};


typedef NS_ENUM(NSUInteger, SMLValidateFileMenu) {
    SMLValidateFileMenuRevealInFinder = 8,
    SMLValidateFileMenuInfo = 10,
	SMLValidateFileMenuPreview = 48,
    SMLValidateFileMenuQuickLook = 49,
    SMLValidateFileMenuShare = 50,
};


typedef NS_ENUM(NSUInteger, SMLValidateEditMenu) {
    SMLValidateEditMenuAllItemsActiveForSelectDelete = 11,
    SMLValidateEditMenuAutoSuggestCompletions = 12,
};


typedef NS_ENUM(NSUInteger, SMLValidateViewMenu) {
    SMLValidateViewMenuSyntaxColors = 11,
    SMLValidateViewMenuLineNumbers = 19,
    SMLValidateViewMenuStatusBar = 17,
    SMLValidateViewMenuInvisibleCharacters = 18,
    SMLValidateViewMenuLineWrap = 10,
    SMLValidateViewMenuPathBar = 20,
    SMLValidateViewMenuSplitWindow = 100,
    SMLValidateViewMenuSplitWindowHorizontally = 101,
    SMLValidateViewMenuHighlightCurrentLine = 120,
    SMLValidateViewMenuPageGuide = 132,
    SMLValidateViewMenuCascadeWindows = 133,
    SMLValidateViewMenuStockholm = 0,
    SMLValidateViewMenuCopenhagen = 1,
    SMLValidateViewMenuOslo = 2,
    SMLValidateViewMenuHelsinki = 3,
    SMLValidateViewMenuDocuments = 33,
    SMLValidateViewMenuTabBar = 34,
};


typedef NS_ENUM(NSUInteger, SMLValidateTextMenu) {
    SMLValidateTextMenuEncodings = 201,
    SMLValidateTextMenuAllActiveWhenTextSelected = 202,
	SMLValidateTextMenuCommentUncomment = 203,
    SMLValidateTextMenuSyntax = 212,
};


typedef NS_ENUM(NSUInteger, SMLValidateToolsMenu) {
    SMLValidateToolsMenuRunText = 1,
    SMLValidateToolsMenuFunctions = 2,
	SMLValidateToolsMenuCreateSnippetFromSelection = 5,
    SMLValidateToolsMenuInsertColor = 6,
    SMLValidateToolsMenuRunSelectionInline = 9,
    SMLValidateToolsMenuHexView = 10,
    SMLValidateToolsMenuNewSnippetCommand = 11,
};


typedef NS_ENUM(NSUInteger, SMLValidateDocumentsMenu) {
    SMLValidateDocumentsMenuNextPrevious = 1002,
};


typedef NS_ENUM(NSUInteger, SMLValidateWindowMenu) {
    SMLValidateWindowMenuMergeAllWindows = 1003,
};


typedef NS_ENUM(NSUInteger, SMLPreferencesToolbarItem) {
	SMLPreferencesToolbarItemGeneral = 0,
	SMLPreferencesToolbarItemAdvanced = 1,
};


typedef NS_ENUM(NSUInteger, SMLSplitWindow) {
	SMLSplitWindowNoSplit = 0,
	SMLSplitWindowVertically = 1,
    SMLSplitWindowHorizontally = 2,
};


typedef NS_ENUM(NSUInteger, SMLUserInterfaceDirection) {
	SMLUserInterfaceDirectionLeftRight = 0,
	SMLUserInterfaceDirectionRightLeft = 1,
    SMLUserInterfaceDirectionUpDown = 2,
};


typedef NS_ENUM(NSUInteger, SMLLineEndings) {
	SMLLineEndingsUnix = 0,
    SMLLineEndingsWindows = 1,
    SMLLineEndingsMacOS9 = 2,
};


typedef NS_ENUM(NSUInteger, SMLTheme) {
	SMLThemeStockholm = 0,
    SMLThemeCopenhagen = 1,
    SMLThemeOslo = 2,
    SMLThemeHelsinki = 3,
};


typedef NS_ENUM(NSUInteger, SMLDocumentChange) {
	SMLDocumentChangeAdd = 0,
    SMLDocumentChangeRemove = 1,
};


typedef NS_ENUM(NSUInteger, SMLColorArray) {
	SMLColorArrayRed = 0,
    SMLColorArrayGreen = 1,
    SMLColorArrayBlue = 2,
    SMLColorArrayAlpha = 3,
};


typedef NS_ENUM(NSUInteger, SMLAdvancedFindSearchScope) {
	SMLAdvancedFindSearchScopeCurrentDocument = 0,
    SMLAdvancedFindSearchScopeAllDocuments = 1,
    SMLAdvancedFindSearchScopeFolder = 2,
    SMLAdvancedFindSearchScopeChoose = 4,
};


typedef NS_ENUM(NSUInteger, SMLContentSplitView) {
	SMLContentSplitViewFirst = 0,
    SMLContentSplitViewSecond = 1,
};


typedef NS_ENUM(NSUInteger, SMLPreferencesToolbarItems) {
	SMLPreferencesToolbarItemsGeneral = 0,
    SMLPreferencesToolbarItemsAdvanced = 1,
};


typedef NS_ENUM(NSUInteger, SMLChangeEncodingUndo) {
	SMLChangeEncodingUndoEncoding = 0,
    SMLChangeEncodingUndoString = 1,
};


typedef NS_ENUM(NSUInteger, SMLSyntaxPopUpMenu) {
    SMLSyntaxPopUpMenuSmultron = 0,
};


typedef NS_ENUM(NSUInteger, SMLTextViews) {
    SMLTextViewsFirst = 0,
    SMLTextViewsSecond = 1,
};


typedef NS_ENUM(NSUInteger, SMLErrors) {
    SmultronSaveErrorEncodingInapplicable = 1,
};


typedef NS_ENUM(NSUInteger, SMLInfo) {
	SMLInfoCharacters = 0,
	SMLInfoWords = 1,
	SMLInfoSelection = 2,
	SMLInfoPosition = 3,
	SMLInfoCreated = 4,
	SMLInfoModified = 5,
	SMLInfoSize = 6,
	SMLInfoSyntax = 7,
	SMLInfoEncoding = 8,
};


typedef NS_ENUM(NSUInteger, SMLRenameAlert) {
	SMLRenameAlertCancel = 0,
	SMLRenameAlertChange = 1,
};


typedef NS_ENUM(NSUInteger, SMLChoicesSection) {
	SMLChoicesSectionView = 0,
	SMLChoicesSectionThemes = 1,
};


typedef NS_ENUM(NSUInteger, SMLChoicesView) {
	SMLChoicesViewLineNumbers = 0,
	SMLChoicesViewSyntaxColors = 1,
};


typedef NS_ENUM(NSUInteger, SMLCheckDelete) {
	SMLCheckDeletePerform = 0,
	SMLCheckDeleteCancel = 1,
};


typedef NS_ENUM(NSUInteger, SMLStepper) {
	SMLStepperBack = 0,
	SMLStepperForward = 1,
};


typedef NS_ENUM(NSUInteger, SMLSectionInMaster) {
	SMLSectionInMasterRoot = 0,
};



@interface SMLConstants : NSObject



@end
